<html>
	<head>
		<title>FBA-Konzept: Embedded Software - Kropatschek</title>
		<link rel="stylesheet" type="text/css" href="fba.css">
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
	</head>
	<body>
	<div align="center">
		<div id="page">
				<h2>FBA-Informatik: Konzeptseite</h2>
				<h1>Embedded Software: ein L&#246;troboter</h1>
			<h3>von Lukas Kropatschek</h3>
			<div align="left">
				<div class="headline">Einleitung</div>
				<br>
				<div id="text">
				<div align="justify">
				Willkommen auf der Konzeptseite! Ich werde versuchen, hier mein Konzept
				f&#252;r das Thema meiner Fachbereichsarbeit weitesgehend vorzustellen,
				um dem Leser einen guten Einblick bzw. &#220;berblick &#252;ber das Projekt
				zu erm&#246;glichen. Kleine &#196;nderungen vorbehalten.<br>
				<br>
				<b>Inhalt:</b><br>
				<a href="#aufbau">Aufbau</a><br>
				<a href="#hardware">Hardware</a><br>
				<a href="#software">Software</a><br>
				<a href="#status">Status</a><br>
				<a href="#gliederung">Gliederung</a><br>
				</div>
				<br>
				</div>

				<br>
				<a name="aufbau"><div class="headline">Aufbau</div></a>
				<br>
				<div id="text">
				<div align="justify">
				Der SolderBot besteht aus mehreren Bauteilen und kleinen Schaltungen
				auf die ich im folgenden Abschnitt partiell eingehen werde. Im wesentlichen
				besteht der SolderBot aus 3 manuell oder automatisch steuerbaren Achsen.
				Auf diesen 3 Achsen wird ein L&#246;tkolben bewegt. Dies erm&#246;glicht
				sehr pr&#228;zise L&#246;tarbeit und vorallem absolut ruhiges L&#246;tverhalten
				welches durch die eigene Hand wom&#246;glich nie erreicht werden k&#246;nnte.
				<br>
				Gesteuert wird der SolderBot mit einer Maus und f&#252;r die visuelle Ausgabe
				sorgt ein ehemaliges Handy-Display. Betrieben wird der SolderBot von einem
				Arduino-Microcontroller-Board, auf dem auch die Programmierung erfolgt.
				
				<br>
				<br><div class="subheadline">Basis:</div>
				Die Basis des SolderBots ist der Unterteil eines alten Scanners. Dieser
				Part ist mit einem bipolaren Schrittschaltmotor best&#252;ckt und dient
				als X-Achse. Auf einer Vorrichtung, auf der damals die Leuchtstoffr&#246;hre
				des Scanners war, ist ein Ausleger aufgebaut. Dieser erm&#246;glicht es
				auf die Oberseite der auf Plastikst&#252;tzen montierterten Holzplatte 
				zu gelangen. Auf diesem Aufbau wird die Y-Achse verwirklicht, durch einen
				weiteren Schrittschaltmotor wird ein weiterer Riemen bewegt, an welchem
				ein dritter Aufbau befestigt ist, der auf einer Metallstange gef&#252;hrt 
				wird. Dieser dritte Aufbau erm&#246;glicht eine Bewegung entlang der Z-Achse.
				Auf dieser Vorrichtung wird au&#223;erdem der L&#246;tkolben befestigt.
				F&#252;r Test- oder Demonstrationszwecke kann man diesen auch durch einen 
				Stift austauschen.<br>
				<br>

				<a href="aufbau/1.jpg"><img src="aufbau/1t.jpg" alt="thumb"></a><br>
				<i>Arbeitsplatte auf Scannergeh&#228;use mit Y-Achse-Aufbau</i><br><br>
				<a href="aufbau/3.jpg"><img src="aufbau/3t.jpg" alt "thumb2"></a><br>
				<i>Nahaufnahme Y-Achse-Aufbau</i><br>
				<br>
	
				<a href="aufbau/">Weitere Bilder der Konstruktion</a>
				<br>
				<br><div class="subheadline">Schaltungen:</div>
				Um die drei bipolaren Schrittschaltmotoren ansteuern zu k&#246;nnen werden
				drei kleine Schaltungen ben&#246;tigt. Es handelt sich dabei um einen IC
				(Integrated Circuit) welcher im Elektronikfachhandel leicht und preiswert
				zu erhalten ist: L293 Four Channel Motor Driver.<br><br>
				Dieser IC wird mit dem Microcontroller nach folgender Schematik verbunden:<br>
				<br><a href="l293.png"><img src="l293t.png"></a><br>
				<i><a href="http://www.arduino.cc/en/Reference/StepperBipolarCircuit">Bildquelle</a></i>
				<br><br>
				Es handelt sich hierbei um eine doppelte H-Br&#252;cke die das schnelle
				Umschalten der Spannungssignale erm&#246;glicht und an den Motor leitet.
				<br><br>
				Au&#223;erdem wird noch eine weitere kleinere Schaltung f&#252;r den
				LCD-Display ben&#246;tigt, auf diese werde ich eingehen sobald ich eine
				schematische Zeichung f&#252;r diese entworfen habe.<br>
				</div>
				<br>
				</div>

				
				<br>
				<a name="hardware"><div class="headline">Hardware</div></a>
				<br>
				<div id="text">
				<div align="justify">
				Diese Liste soll mir ein wenig als Gedankenst&#252;tze dienen und wird
				je nach Ver&#228;nderung erweitert.
				Diese Hardware wurde ben&#246;tigt:<br>
				<ul>
						<li>3x L293E 4 Channel Driver IC (<a href="http://www.datasheetcatalog.com/datasheets_pdf/L/2/9/3/L293B.shtml">Datenblatt</a>)</li>
						<li>6x 1k Ohm Wiederst&#228;nde</li>
						<li>6x 10k Ohm Wiederst&#228;nde</li>
						<li>8x 680 Ohm Wiederst&#228;nde</li>
						<li><a href="http://arduino.cc">Arduino Microcontroller-Board</a> mit ATMega168 MCU (<a href="http://www.atmel.com/dyn/resources/prod_documents/doc2545.pdf">Datenblatt</a>)</li>
						<li>Nokia 6610 Handydisplay mit EPSON Controller (<a href="http://www.mikrocontroller.net/attachment/3592/S1D15G10.pdf">Datenblatt</a>)</li>
						<li>6x BC548C Transistoren</li>
						<li>3x Bipolarer Schrittschaltmotor</li>
						<li>altes Scannergeh&#228;use</li>
						<li>Holzplatte</li>
						<li>M&#228;rklin Bausatz: "Riesenrad Wien" - f&#252;r die Achsenaufbauten</li>
						<li>kleiner L&#246;tkolben</li>
						<li>viel Zeit, genausoviel L&#246;tzinn, Linux, einen gut beratenden Vater in
						Sachen Elektrotechnik und Kaffee.</li>
				</ul>
				</div>
				<br>
				</div>


				<br>
				<a name="software"><div class="headline">Software</div></a>
				<br>
				<div id="text">
				<div align="justify">
				Gleich vorweg gilt zu sagen, ohne OpenSource g&#228;be es dieses Projekt nicht.
				Durch OpenSource (bzw. in dem Fall GNU/Linux) habe ich erst das Interesse f&#252;r die Materie
				entwickelt und ausserdem zu programmieren begonnen.<br><br>
				Geschrieben wird die Software unter <a href="http://archlinux.de">Arch Linux</a>
				mit dem <a href="http://vim.org">(G)VIM</a> Editor mit Unterst&#252;tzung
				der <a href="http://www.nongnu.org/avr-libc/">AVR Libc</a> Bibliothek
				<!--, der <a href="http://arduino.cc/en/Reference/HomePage">Arduino</a> 
				Bibliothek--> und mit den avr-gcc Tools wird die Software &#252;bersetzt und gelinkt.<br>
				Die Software wird in C/C++ geschrieben und mit Hilfe einer seriellen Verbindung (USB) in
				den Flash-Speicher der MCU geladen. <a href="#repo">Die Projektquellen</a> werden in einem <a href="http://git.or.cz/">git</a>
				Repository "aufbewahrt".
				<br><br>
				Die Software besteht grob genommen aus zwei Teilen. Dem GUI Teil (Grafische Benutzeroberfl&#228;che)
				und dem SolderManager Code. Mit Hilfe einer Tastatur und der GUI kann der Benuter den SolderBot
				steuern. &#220;ber die serielle Schnittstelle RS-232 (USB) kann der Benuterz sogenannte SBCoordMaps
				auf den Microcontroller laden. In diesen Karten ist die abzufahrende Spur eingetragen. Der Microcontroller
				wird den L&#246;tkolben dann wie gew&#252;nscht dieser Spur folgen lassen.<br>

				Der AVR Code besteht wiederum aus mehreren Teilen/Modulen:<br>
				<ul>
					<li>SBCore Kernmodul</li>
					<li>I/O Modul</li>
					<li>SolderManager Modul</li>
					<li>Stepper (Schrittschaltmotor) Treiber</li>
					<li>LCD Treiber</li>
					<li>PS/2 Treiber</li>
					<li>SBGT Modul</li>
				</ul><br>
				<div class="subheadline">SBCore Kernmodul</div>
				Dieser Teil der Software ist der Kern des Projekts bzw. des Roboters.
				In dieser Klasse laufen alle Str&#228;nge zusammen und die Hauptschleifen
				des Robotors werden durchgearbeite. Dieser Part steuert die ihm zugrunde
				liegenden Module also die I/O und SolderControl Module.<br><br>
				<b>Die Funktionalit&#228;t dieser Klasse wurde in die main.cpp also die
				main Funktion verlegt. Eine eigene Klasse daf&#252;r hat sich als unpraktisch
				und Programmspeicher raubend erwiesen.</b>
				<br>
				<br>
				<div class="subheadline">I/O Modul</div>
				Dieses Modul ist f&#252;r den gesamten Input und Output des Robotors zust&#228;ndig.
				Es schickt die eingehenden und ausgehenden Daten an die richtigen Programmteile, sodass
				dieses korrekt funktionieren k&#246;nnen.
				<br>
				<br>
				<div class="subheadline">SolderManager Modul</div>
				In dieser Klasse werden die drei Schrittschaltmotoren gesteuert. Das bedeuted, dass dieses
				Modul die Stepper Treiber initialisiert und so steuert/ausf&#252;hrt, wie es vom I/O Modul 
				mitgeteilt wird. So wird im Endeffekt dann gel&#246;tet, daher auch der Name. 
				Theoretisch k&#246;nnte das I/O Modul den Stepper Treiber direkt ansprechen
				nur finde ich die Methode aufgrund von Abstraktion vorteilbehafteter.
				<br>
				<br>
				<div class="subheadline">Stepper Treiber</div>
				Hier erfolgt die Low-Level (hardwarenahe) Programmierung f&#252;r die Schrittschaltmotoren.
				Da die Schrittschaltmotoren &#252;ber eine H-Br&#252;cke angesteuert werden, ist es m&#246;glich
				nur zwei Pins (Anschl&#252;sse am MCU) zu ben&#252;tzen. Es gibt vier Sequenzen zur Kontrolle eines
				Schrittschaltmotors:<br>
				<table width="30%"cellpadding="5" cellspacing="0">
						<TR style="background:#85aeff;"><TD>Step</TD><TD>C0</TD><TD>C1</TD></TR>
						<TR><TD style="background:#f7f7f7;">1</TD><TD>0</TD><TD>1</TD></TR>
						<TR><TD style="background:#f7f7f7;">2</TD><TD>1</TD><TD>1</TD></TR>
						<TR><TD style="background:#f7f7f7;">3</TD><TD>1</TD><TD>0</TD></TR>
						<TR><TD style="background:#f7f7f7;">4</TD><TD>0</TD><TD>0</TD></TR>
				</table>
				<i>C0, C1 - Controlsignal 0/1 ^= MCU Pins - 0 = LOW, 1 = HIGH</i>
				<br>
				<br>
				<div class="subheadline">LCD Treiber</div>
				F&#252;r die grafische Ausgabe abseits des Computers wird ein Display aus einem alten
				Nokia Handy verwendet. Das ist ein weiterer Low-Level Part der Software, ein Treiber
				f&#252;r den Epson LCD Controller, der auf dem Display verbaut ist. Da es ein Farbdisplay
				ist, war dieser Teil bis jetzt der Aufw&#228;ndigste des ganzen Projekts.<br>
				Es war nicht leicht aber ich habe es geschafft (mit Hilfe 
				des Datenblatts und einiger Quellen aus dem Internet)
				einen Treiber f&#252;r dieses Ger&#228;t zu schreiben. F&#252;r mehr Details verweise ich 
				inzwischen auf 
				<a href="http://blog.lukrop.bplaced.net/archives/Nokia-6610-LCD-+-Arduino.html">einen meiner Blog Eintr&#228;ge</a>.
				<br>
				<br>
				<a href="aufbau/lcd.jpg"><img src="aufbau/lcdt.jpg"></a><br>
				<i>LCD in action</i><br><br>
				<a href="aufbau/tux.jpg"><img src="aufbau/tuxt.jpg"></a><br>
				<i>Tux - Linux Maskottchen - auf dem LCD</i>
				<br><br>
				<div class="subheadline">PS/2 Treiber</div>
				Mit diesm St&#252;cken Code wird eine alte Tastatur als Eingabeger&#228;t angesteuert.
				Durch ein wenig herumtesten, habe ich auch alle Keycodes (die bei Tastendruck empfangen
				werden) herausgefunden. Jetz kann damit bereits eingiges gesteuert werden, da mir somit ~105
				verschiedene Tasten &#252;ber 2 Pins zur Verf&#252;gung stehen.
				<br><br>
				<div class="subheadline">SBGT Modul</div>
				Das <b>S</b>older<b>B</b>ot <b>G</b>raphics <b>T</b>oolkit ist f&#252;r die verschiedenen
				Informationen, und die Art und Weise wie sie dargestellt werden, die am Display ausgegeben werden
				zust&#228;ndig. In dieser Klasse sind diverse Routinen f&#252;r die Darstellung verschiedener
				Widgets enthalten. Zum Beispiel eine Darstellung des Koordinatensystems in dem sich der L&#246;tarm
				bewegt, mit genauen Positionsangaben und diversen anderen Informationen. Nat&#252;rlich ben&#252;tz
				dieses Graphiktoolkit den LCD Treiber zur Darstellung am Display.
				<br><br>
				<div class="subheadline">UML-Diagramme</div>
				Ich arbete zur Zeit an diversen UML-Diagrammen f&#252;r die GUI Anwendung
				und werde diese so bald wie m&#246;glich hier auf die Seite stellen.
				Inzwischen gibt es hier das beinhae fertige UML-Diagramm f&#252;r den AVR-Code:<br>
				<a href="classdiagram.png"><img src="classdiagramt.png"></a>
				<br>
				<br>
				<a name="repo"><div class="subheadline">git Repository</div></a>
				Vor kurzem habe ich auch ein <a href="http://git.or.cz/">git</a> Repository eingerichtet.
				Dieses ist unter <a href="http://repo.or.cz/w/solderbot.git">dieser Adresse zu finden</a>. Hier k&#246;nnen
				die gesamte Projektquellen heruntergeladen werden oder aber auch, kann man &#252;ber den 
				<a href="http://repo.or.cz/w/solderbot.git?a=rss">RSS Feed</a> am aktuellen Stand bleiben.
				</div>

				<br>
				</div>

		</div>

				<br>
				<a name="status"><div class="headline">Status</div></a>
				<br>
				<div id="text">
				<div align="justify">
				Ich werde versuchen in dieser Sektion, den aktuellen Status des Projekts, in einzelnen Teilbereichen,
				so gut wie m&#246;glich einsichtlich zu machen.<br>
				<div class="subheadline">TODO Liste</div>
				Das ist die Liste der momemtan anstehenden Aufgaben, nach Priorit&#228;t geordnet. <br>
				<table width=98% cellpadding="5" cellspacing="0">
				<TR class=header><TD>Status</TD>         <TD>Aufgabe</TD>      <TD class=prio>Priorit&#228;t</TD></TR>

				<TR class=work><TD class=status><img src="work.png"> 0%</TD> <TD>SolderManager implementiern</TD> <TD class=prio>2</TD></TR>
				
				<TR class=work><TD class=status><img src="work.png"> 95%</TD> <TD>I/O Manager implentieren</TD> <TD class=prio>2</TD></TR>
		
				<TR class=work><TD class=status><img src="work.png"> 95%</TD> <TD>SBGraphics Toolkit implementiern</TD><TD class=prio>2</TD></TR>
				
				<TR class=work><TD class=status><img src="work.png"> 50%</TD> <TD>UML Diagramme anfertigen</TD><TD class=prio>1</TD></TR>

				<TR class=done><TD class=status><img src="done.png"> 100%</TD> <TD>Stepper Treiber implemntiern</TD>  <TD class=prio>-</TD></TR>
		
				<TR class=done><TD class=status><img src="done.png"> 100%</TD> <TD>Basis Funktionen implementiern</TD>  <TD class=prio>-</TD></TR>
		
				<TR class=done><TD class=status><img src="done.png"> 100%</TD> <TD>PS/2 Treiber implementiern</TD>  <TD class=prio>-</TD></TR>
				
				<TR class=done><TD class=status><img src="done.png"> 100%</TD> <TD>LCD Treiber optimiern</TD>  <TD class=prio>-</TD></TR>
		
				</table>
				<i>Priorit&#228;t: 0 = gering 3 = hoch.</i>
				</div>
				</div>
				
				<br>
				<a name="gliederung"><div class="headline">Gliederung</div></a>
				<br>
				<div id="text">
				<div align="justify">
				In dieser Sektion werde ich versuchen die Gliederung der Fachbereichsarbeit aufzustellen,
				diese soll eher eine Gedankenst&#252;tze bzw. eine Planungshilfe darstellen. &#196;nderungen vorbehalten.<br>
				<br>

				<ul>
						<li>Vorwort
						<li>Eidesstattliche Erkl&#228;rung
						<li>Danksagungen
						<li>Inhaltsverzeichnis
						<br><br>
						<li>Einleitung
						<ul>
							<li>Embedded Software im Alltag
							<li>AVR-RISC Architektur
								<ul>
									<li>Warum AVR-RISC
							</ul>
							<li>Arduino - ein OpenSource Entwicklungsboard
						</ul>

						<li>Der SolderBot
						<li>Hardware Aufbau
						<ul>
							<li>Ben&#246;tigte Schaltungen
						</ul>
						<li>Software Aufbau/Design
						<ul>
							<li>Programmierung eines AVR-RISC Microcontroller
							<li>? UML
						</ul>
						<li>Implemntierung
						<ul>
						<li>I/O Management / Reaktion auf Benutzerinteraktion
						<ul>
							<li>IOManager - Ein/Ausgabemodul
							<ul>
								<li>Nutzung von externen &amp; internen Interrupts
							</ul>
							<li>PS/2 Protokoll
							<li>Serielle Schnittstelle
						</ul>
						<li>Ansteuerung des LCD
						<ul>
							<li>LCD-Controller Treiber
							<li>SBGT - Grafikbibliothek
							<ul>
								<li>SViews
							</ul>
						</ul>
						<li>Ansteuerung der Schrittschaltmotoren
						<ul>
							<li>SolderManager - L&#246;troutinen
							<li>SMap - L&#246;tplan
					</ul>
						<li>Zusammenf&#252;hrung aller Funktionen
						<ul>
							<li>Hauptschleife
						</ul>
				</ul>
				<li>Fazit
				<li>Anhang
				<ul>
					<li>Glossar
					<li>Literaturliste
				</ul>
			</ul>

				</div>
				</div>

	</div>
	<br>
	&#169; 2008 Lukas Kropatschek - lukas [dot] krop [at] gmail [dot] com - Letztes Update: 18:12 16.08.08 CEST
	</div>
	</body>
</html>
